std::asin(std::complex)(3)

NAME
std::asin(std::complex) - std::asin(std::complex)

Synopsis
   Defined in header <complex>
   template< class T > (since C++11)
   complex<T> asin( const complex<T>& z );
   Computes complex arc sine of a complex value z. Branch cut exists outside the
   interval [−1 ; +1] along the real axis.

Parameters
   z - complex value

Return value
   If no errors occur, complex arc sine of z is returned, in the range of a strip
   unbounded along the imaginary axis and in the interval [−π/2; +π/2] along the
   real axis.
   Errors and special cases are handled as if the operation is implemented by -i *
   std::asinh(i*z), where i is the imaginary unit.

Notes
   Inverse sine (or arc sine) is a multivalued function and requires a branch cut on
   the complex plane. The branch cut is conventionally placed at the line segments
   (-∞,-1) and (1,∞) of the real axis.
   The mathematical definition of the principal value of arc sine is asin z = -iln(iz +
   √
   1-z2
   )
   For any z, asin(z) = acos(-z) -
   π
   2

Example
// Run this code
 #include <iostream>
 #include <cmath>
 #include <complex>
 int main()
 {
     std::cout << std::fixed;
     std::complex<double> z1(-2, 0);
     std::cout << "acos" << z1 << " = " << std::acos(z1) << '\n';
     std::complex<double> z2(-2, -0.0);
     std::cout << "acos" << z2 << " (the other side of the cut) = "
               << std::acos(z2) << '\n';
     // for any z, acos(z) = pi - acos(-z)
     const double pi = std::acos(-1);
     std::complex<double> z3 = pi - std::acos(z2);
     std::cout << "cos(pi - acos" << z2 << ") = " << std::cos(z3) << '\n';
 }

Output:
 asin(-2.000000,0.000000) = (-1.570796,1.316958)
 asin(-2.000000,-0.000000) (the other side of the cut) = (-1.570796,-1.316958)
 sin(acos(-2.000000,-0.000000) - pi/2) = (-2.000000,-0.000000)

See also
   acos(std::complex) computes arc cosine of a complex number (\({\small\arccos{z}
   (C++11) }\)arccos(z))
                       (function template)
   atan(std::complex) computes arc tangent of a complex number (\({\small\arctan{z}
   (C++11) }\)arctan(z))
                       (function template)
   sin(std::complex) computes sine of a complex number (\({\small\sin{z} }\)sin(z))
                       (function template)
   asin
   asinf computes arc sine (\({\small\arcsin{x} }\)arcsin(x))
   asinl (function)
   (C++11)
   (C++11)
   asin(std::valarray) applies the function std::asin to each element of valarray
                       (function template)